#ifndef FMMBASE_UTIL_H
#define FMMBASE_UTIL_H

#include "f2c.h"
#include "fmmbase.P"

#define f2d(base, x, y) base[y][x]

#define f2p(base, x) base[][x]

#define f2r(base) &((base)[0][0])

#define f2c(base, x) (typeof(*(base)) (*)[x]) (base)

#define f2(base, x, y) base[y-1][x-1]

#define f1(base, x) base[x-1]

typedef int (*closefunc)(integer* i,
                         integer* j, 
                         doublereal *eps, 
                         doublereal xinfo1[8],
                         doublereal xinfo2[8],
                         integer iflag[2],
                         doublereal xout[4]);

extern closefunc close1;

static 
integer fmmpart3d(doublereal f2p(sources, 3), 
                  integer nsources, 
                  doublereal monocharge[], 
                  doublereal dipstr[], 
                  doublereal f2p(dipvec, 3),
                  doublereal pot[], 
                  doublereal potx[], 
                  doublereal poty[], 
                  doublereal potz[],
                  doublereal work[], 
                  integer lenw, 
                  integer iprec, 
                  integer iflagtype, 
                  integer iderivonoff, 
                  closefunc close, 
                  doublereal epsclose, 
                  integer inform[5]){
  integer ier;
  fmmpart3d_(f2r(sources),
             &nsources,
             monocharge,
             dipstr,
             f2r(dipvec),
             pot,
             potx,
             poty,
             potz,
             work,
             &lenw,
             &iprec,
             &iflagtype,
             &iderivonoff,
             (S_fp) close,
             &epsclose,
             &ier,
             inform);
  return ier;
}
               

#endif //FMMBASE_UTIL_H
