#include <stdlib.h>

#include "test-common.h"

doublereal compare_meansq(doublereal vec1[], doublereal vec2[], 
                    integer n) {
  integer i;
  doublereal diff = 0;
  doublereal total = 0;

  for (i = 1; i <= n; i++) {
    diff += pow((f1(vec1, i) - f1(vec2, i)), 2);
    total += pow(f1(vec1, i), 2) + pow(f1(vec2, i), 2);
  }

  return sqrt(diff/total);
}

void direct_eval(doublereal f2p(sources,3), integer nsources,
                 doublereal monocharge[namax],
                 doublereal dipstr[namax], 
                 doublereal f2p(dipvec, 3),
                 doublereal pot[namax], 
                 doublereal potx[namax], 
                 doublereal poty[namax], 
                 doublereal potz[namax],
                 doublereal work[namax], integer maxwrk_,
                 integer iflagtype, integer iderivonoff,
                 integer start, integer end) {
  integer i, j;
  doublereal dist, dx, dy, dz;
  doublereal ip, dist3, dist5;

  for (i = start; i <= end; i++) f1(pot, i) = 0;
  
  if (iderivonoff == 1)
    for (i = start; i <= end; i++) {
      f1(potx, i)  = 0;
      f1(poty, i) = 0;
      f1(potz, i) = 0;
    };
  
  if (iflagtype == 0 || iflagtype == 2) {
    for (i = start; i <= end; i++)
      for (j = 1; j <= nsources; j++)
        if (i != j) {
          dx = f2(sources, 1, i) - f2(sources, 1, j);
          dy = f2(sources, 2, i) - f2(sources, 2, j);
          dz = f2(sources, 3, i) - f2(sources, 3, j);
          dist = sqrt(dx*dx + dy*dy + dz*dz);
          f1(pot, i) += f1(monocharge, j)/dist;
        };

    if (iderivonoff == 1) 
      for (i = start; i <= end; i++)
        for (j = 1; j <= nsources; j++)
          if (i != j) {
            dx = f2(sources, 1, i) - f2(sources, 1, j);
            dy = f2(sources, 2, i) - f2(sources, 2, j);
            dz = f2(sources, 3, i) - f2(sources, 3, j);
            dist = sqrt(dx*dx + dy*dy + dz*dz);
            f1(potx, i) += f1(monocharge, j)*dx/(dist*dist*dist);
            f1(poty, i) += f1(monocharge, j)*dy/(dist*dist*dist);
            f1(potz, i) += f1(monocharge, j)*dz/(dist*dist*dist);
          };
  };

  if (iflagtype == 1 || iflagtype == 2) {
    for (i = start; i <= end; i++)
      for (j = 1; j <= nsources; j++)
        if (i != j) {
          dx = f2(sources, 1, i) - f2(sources, 1, j);
          dy = f2(sources, 2, i) - f2(sources, 2, j);
          dz = f2(sources, 3, i) - f2(sources, 3, j);
          dist = sqrt(dx*dx + dy*dy + dz*dz);
          f1(pot, i) += f1(dipstr, j)
            * (dx*f2(dipvec, 1, j) + dy*f2(dipvec, 2, j) + dz*f2(dipvec, 3, j))
            / (dist*dist*dist);
        };

    if (iderivonoff == 1)
      for (i = start; i <= end; i++)
        for (j = 1; j <= nsources; j++)
          if (i != j) {
            dx = f2(sources, 1, i) - f2(sources, 1, j);
            dy = f2(sources, 2, i) - f2(sources, 2, j);
            dz = f2(sources, 3, i) - f2(sources, 3, j);
            ip = dx*f2(dipvec, 1, j) 
              + dy*f2(dipvec, 2, j) 
              + dz*f2(dipvec, 3, j);
            dist = sqrt(dx*dx + dy*dy + dz*dz);
            dist3 = dist*dist*dist;
            dist5 = dist*dist*dist*dist*dist;

            f1(potx, i) += -1 * f1(dipstr, j) * f2(dipvec, 1, j) / dist3
              + 3 * f1(dipstr, j) * ip * dx / dist5;
            f1(poty, i) += -1 * f1(dipstr, j) * f2(dipvec, 2, j) / dist3
              + 3 * f1(dipstr, j) * ip * dy / dist5;
            f1(potz, i) += -1 * f1(dipstr, j) * f2(dipvec, 3, j) / dist3
              + 3 * f1(dipstr, j) * ip * dz / dist5;
          };
  };
}

/* doublereal dlaran(integer iseed[4]) { */
/*   integer m1 = 494, m2 = 322, m3 = 2508, m4 =2549; */
/*   integer ipw2 = 4096; */
/*   doublereal r = 1.0/ipw2; */

/*   integer it1, it2, it3, it4; */
  
/*   it4 = f1(iseed, 4)*m4; */
/*   it3 = it4/ipw2; */
/*   it4 -= ipw2*it3; */
/*   it3 += f1(iseed, 3)*m4 + f1(iseed, 4)*m3; */
/*   it2 = it3/ipw2; */
/*   it3 -= ipw2*it3; */
/*   it2 += f1(iseed, 2)*m4 + f1(iseed, 3)*m3 + f1(iseed, 4)*m2; */
/*   it1 = it2/ipw2; */
/*   it2 -= ipw2*it1; */
/*   it1 += f1(iseed, 1)*m4 + f1(iseed, 2)*m3 + f1(iseed, 3)*m2 + f1(iseed, 4)*m1; */
/*   it1 %= ipw2; */
  
/*   f1(iseed, 1) = it1; */
/*   f1(iseed, 2) = it2; */
/*   f1(iseed, 3) = it3; */
/*   f1(iseed, 4) = it4; */

/*   return r*(it1 + r*(it2 + r*(it3 + r*it4))); */
/* } */

#if 1
doublereal dlaran(integer *iseed)
{
    /* System generated locals */
    doublereal ret_val;

    /* Local variables */
    static integer it1, it2, it3, it4;


/*  -- LAPACK auxiliary routine (version 3.0) -- */
/*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd., */
/*     Courant Institute, Argonne National Lab, and Rice University */
/*     February 29, 1992 */

/*     .. Array Arguments .. */
/*     .. */

/*  Purpose */
/*  ======= */

/*  DLARAN returns a random real number from a uniform (0,1) */
/*  distribution. */

/*  Arguments */
/*  ========= */

/*  ISEED   (input/output) INTEGER array, dimension (4) */
/*          On entry, the seed of the random number generator; the array */
/*          elements must be between 0 and 4095, and ISEED(4) must be */
/*          odd. */
/*          On exit, the seed is updated. */

/*  Further Details */
/*  =============== */

/*  This routine uses a multiplicative congruential method with modulus */
/*  2**48 and multiplier 33952834046453 (see G.S.Fishman, */
/*  'Multiplicative congruential random number generators with modulus */
/*  2**b: an exhaustive analysis for b = 32 and a partial analysis for */
/*  b = 48', Math. Comp. 189, pp 331-344, 1990). */

/*  48-bit integers are stored in 4 integer array elements with 12 bits */
/*  per element. Hence the routine is portable across machines with */
/*  integers of 32 bits or more. */

/*  ===================================================================== */

/*     .. Parameters .. */
/*<       INTEGER            ISEED( 4 ) >*/
/*<       INTEGER            M1, M2, M3, M4 >*/
/*<       PARAMETER          ( M1 = 494, M2 = 322, M3 = 2508, M4 = 2549 ) >*/
/*<       DOUBLE PRECISION   ONE >*/
/*<       PARAMETER          ( ONE = 1.0D+0 ) >*/
/*<       INTEGER            IPW2 >*/
/*<       DOUBLE PRECISION   R >*/
/*<       PARAMETER          ( IPW2 = 4096, R = ONE / IPW2 ) >*/
/*     .. */
/*     .. Local Scalars .. */
/*     .. */
/*     .. Intrinsic Functions .. */
/*<       INTEGER            IT1, IT2, IT3, IT4 >*/
/*<       INTRINSIC          DBLE, MOD >*/
/*     .. */
/*     .. Executable Statements .. */

/*     multiply the seed by the multiplier modulo 2**48 */

/*<       IT4 = ISEED( 4 )*M4 >*/
    /* Parameter adjustments */
    --iseed;

    /* Function Body */
    it4 = iseed[4] * 2549;
/*<       IT3 = IT4 / IPW2 >*/
    it3 = it4 / 4096;
/*<       IT4 = IT4 - IPW2*IT3 >*/
    it4 -= it3 << 12;
/*<       IT3 = IT3 + ISEED( 3 )*M4 + ISEED( 4 )*M3 >*/
    it3 = it3 + iseed[3] * 2549 + iseed[4] * 2508;
/*<       IT2 = IT3 / IPW2 >*/
    it2 = it3 / 4096;
/*<       IT3 = IT3 - IPW2*IT2 >*/
    it3 -= it2 << 12;
/*<       IT2 = IT2 + ISEED( 2 )*M4 + ISEED( 3 )*M3 + ISEED( 4 )*M2 >*/
    it2 = it2 + iseed[2] * 2549 + iseed[3] * 2508 + iseed[4] * 322;
/*<       IT1 = IT2 / IPW2 >*/
    it1 = it2 / 4096;
/*<       IT2 = IT2 - IPW2*IT1 >*/
    it2 -= it1 << 12;
/*<    >*/
    it1 = it1 + iseed[1] * 2549 + iseed[2] * 2508 + iseed[3] * 322 + iseed[4] 
	    * 494;
/*<       IT1 = MOD( IT1, IPW2 ) >*/
    it1 %= 4096;

/*     return updated seed */

/*<       ISEED( 1 ) = IT1 >*/
    iseed[1] = it1;
/*<       ISEED( 2 ) = IT2 >*/
    iseed[2] = it2;
/*<       ISEED( 3 ) = IT3 >*/
    iseed[3] = it3;
/*<       ISEED( 4 ) = IT4 >*/
    iseed[4] = it4;

/*     convert 48-bit integer to a real number in the interval (0,1) */

/*<    >*/
    ret_val = ((doublereal) it1 + ((doublereal) it2 + ((doublereal) it3 + (
	    doublereal) it4 * 2.44140625e-4) * 2.44140625e-4) * 2.44140625e-4)
	     * 2.44140625e-4;
/*<       RETURN >*/
    return ret_val;

/*     End of DLARAN */

/*<       END >*/
} /* dlaran_ */


#else

doublereal dlaran(integer iseed[4]) {
  static char first = 1;
  if (first) {
    srandom(iseed[0]);
    first = 0;
  }
  
  return (doublereal) random()/(doublereal) RAND_MAX;
}

#endif
