#include "test-common.h"
#include "fmmbase.P"

int main(int argc, char* argv[]) {
  integer ier;
  integer inform[5];
  integer iprec;
  integer iflagtype;
  integer iderivonoff;
  integer nsources;
  integer i;
  doublereal epsclose;


  printf("Test # 1001\n");
  f2(sources, 1, 1) = 0;
  f2(sources, 2, 1) = 0;
  f2(sources, 3, 1) = 0;
  f2(sources, 1, 2) = 1;
  f2(sources, 2, 2) = 0;
  f2(sources, 3, 2) = 0;
  f2(sources, 1, 3) = 2;
  f2(sources, 2, 3) = 0;
  f2(sources, 3, 3) = 0;
  nsources = 3;
  
  f1(monocharge, 1) = 1;
  f1(monocharge, 2) = 0;
  f1(monocharge, 3) = 0;

  f1(dipstr, 1) = 1;
  f1(dipstr, 2) = 0;
  f1(dipstr, 3) = 0;

  f2(dipvec, 1, 1) = 1;
  f2(dipvec, 2, 1) = 0;
  f2(dipvec, 3, 1) = 0;
  f2(dipvec, 1, 2) = 1;
  f2(dipvec, 2, 2) = 0;
  f2(dipvec, 3, 2) = 0;
  f2(dipvec, 1, 3) = 1;
  f2(dipvec, 2, 3) = 0;
  f2(dipvec, 3, 3) = 0;

  iprec = 2;
  iflagtype = 2;
  iderivonoff = 1;
  epsclose = 0;

  ier = fmmpart3d(sources, nsources, 
                  monocharge,
                  dipstr, dipvec,
                  pot, potx, poty, potz,
                  work, lenw, 
                  iprec, iflagtype, iderivonoff, 
                  close1, epsclose,
                  inform);

  printf("\npot(1) = %.9f\npot(2) = %.9f\npot(3) = %.9f\npotx(1) = %.9f\npoty(1) = %.9f\npotz(1) = %.9f\npotx(2) = %.9f\npoty(2) = %.9f\npotz(2) = %.9f\npotx(3) = %.9f\npoty(3) = %.9f\npotz(3) = %.9f\n",
         f1(pot, 1), f1(pot, 2), f1(pot, 3),
         f1(potx, 1), f1(poty, 1), f1(potz, 1),
         f1(potx, 2), f1(poty, 2), f1(potz, 2),
         f1(potx, 3), f1(poty, 3), f1(potz, 3));
  
  direct_eval(sources, nsources, 
              monocharge, 
              dipstr, dipvec,
              pot2, potx2, poty2, potz2,
              work, lenw,
              iflagtype, iderivonoff,
              1, nsources);

  printf("\npot(1) = %.9f\npot(2) = %.9f\npot(3) = %.9f\npotx(1) = %.9f\npoty(1) = %.9f\npotz(1) = %.9f\npotx(2) = %.9f\npoty(2) = %.9f\npotz(2) = %.9f\npotx(3) = %.9f\npoty(3) = %.9f\npotz(3) = %.9f\n",
         f1(pot2, 1), f1(pot2, 2), f1(pot2, 3),
         f1(potx2, 1), f1(poty2, 1), f1(potz2, 1),
         f1(potx2, 2), f1(poty2, 2), f1(potz2, 2),
         f1(potx2, 3), f1(poty2, 3), f1(potz2, 3));
  
  printf("\nMean square error in potential = %.9f\n", 
         compare_meansq(pot, pot2, nsources));
  for (i = 1; i <= nsources; i++) {
    f1(work, i) = f1(potx, i);
    f1(work, nsources+i) = f1(poty, i);
    f1(work, 2*nsources+i) = f1(potz, i);
    f1(work, 3*nsources+i) = f1(potx2, i);
    f1(work, 4*nsources+i) = f1(poty2, i);
    f1(work, 5*nsources+i) = f1(potz2, i);
  }


  printf("Mean square error in field = %.9f\n", 
         compare_meansq(&f1(work, 1), &f1(work, 3*nsources+1), nsources));

  return 0;
}

